// -------------------------------------------------------------------------------------
// xsEasyCpp
// Demo de Objeto ListaOpciones
// g++ -g ListaOpciones.cpp -lxseasycpp -LC:/msys64/mingw64/lib -lgtk-3 -lgdk-3 -lz -lgdi32 -limm32 -lshell32 -lole32 -Wl,-luuid -lwinmm -ldwmapi -lsetupapi -lcfgmgr32 -lpangowin32-1.0 -lpangocairo-1.0 -lpango-1.0 -latk-1.0 -lcairo-gobject -lcairo -lgdk_pixbuf-2.0 -lgio-2.0 -lgobject-2.0 -lintl -lglib-2.0 -o ListaOpciones.exe
// g++ -g ListaOpciones.cpp %PKG-XSEASYCPP% -o ListaOpciones.exe
// -------------------------------------------------------------------------------------


// Incluye las librería de xsWindows
#include "include/xsEasyCpp.hpp"

// Se inicializa el renglon de Separadores
Entero xsListaOpciones::separadores=2;
Entero xsListaOpciones::renglones[]={4,8};


// Enumeracion para las columnas de la Lista de Opciones
Numerado
{
  COLUMNA_ICONO,
  COLUMNA_TEXTO
};

// Función para crear el Arbol del Modelo del Primer Combo
Estatica xsModeloArbol* fnCrearModeloMensajes (Vacio);

// Detiene el Ciclo Principal iniciado por gtk_main cuando la ventana es destruida
Estatica Vacio fnSalida(xsObjetoGUI* ventana, xsApuntador datos);

// Función para controlar el Cierre de una Ventana
Estatica Entero fnCierre(xsObjetoGUI* ventana, xsEvento *evento);

// Función para controlar la selección en el Opcion
Vacio fnOpcionSeleccionada(xsObjetoGUI* objeto, Entero* columna);

// Función para Insertar el Elemento Seleccionado
Vacio fnInsertar(xsObjetoGUI* boton, xsApuntador lista);

// Función para modificar el Elemento Seleccionado
Vacio fnModificarSeleccionado(xsObjetoGUI* boton, xsApuntador lista);

// Función para eliminar el Elemento Seleccionado
Vacio fnEliminarSeleccionado(xsObjetoGUI* boton, xsApuntador lista);

// Función para eliminar el Primer Elemento
Vacio fnEliminarPrimero(xsObjetoGUI* boton, xsApuntador lista);

// Función para Seleccionar el primer Elemento
Vacio fnSeleccionarPrimero(xsObjetoGUI* boton, xsApuntador lista);

// Función para DesSeleccionar el primer Elemento
Vacio fnDesSeleccionar(xsObjetoGUI* boton, xsApuntador lista);

// Función para eliminar todos
Vacio fnEliminarTodos(xsObjetoGUI* boton, xsApuntador lista);

// Función para eliminar todos
Vacio fnDesplegarTodos(xsObjetoGUI* boton, xsApuntador lista);

// La variable para la entrada
xsEntrada entDato;

// Función principal de xsEasyWindow
xsPrincipal
{
  // Iniciamos xsEasyWindows
  xsAppInicia;

  // Definimos un objeto de la Clase xsVentana
  xsVentana oVentana(XS_CON_CONTENEDOR);

  // Estableciendo un tamaño para la Ventana                                  
  oVentana.colocarDimensiones(350,350);

  // Centrar
  oVentana.centrar();

  // Coloca el Título
  oVentana.colocarTitulo("xsEasyCpp Demo Lista Opciones");

  // Establece el Icono
  oVentana.colocarIcono("img/js.ico");

  // Establecemos el Bordel del Contenedor
  oVentana.colocarBordeContenedor(10);
    
  // Establece la función de Salida
  oVentana.colocarFuncionSalida(XS_FUNCION_RETORNO (fnSalida));

  // Establece la función de Cierre
  oVentana.colocarFuncionCierre(XS_FUNCION_RETORNO (fnCierre));

  // Preparamos datos para insertar en la Opcion
  xsArbolIterador iterador;
  xsModeloArbol*  modeloMensajes;

  // Crea los modelos
  modeloMensajes = fnCrearModeloMensajes ();

  // Definimos el numero de Separadores
  xsListaOpciones::colocarNumeroSeparadores(1);

  // Creamos una opcion con Modelo
  xsListaOpciones oListaMensajes(modeloMensajes);
  xsObjeto_desreferenciar(modeloMensajes);

  // Visualiza la Columna del Icono
  oListaMensajes.visualizarColumna(xsListaOpciones::tipoColumna::PixBuf,"icon-name",0);
  
  // Visualiza la Columna del Mensaje
  oListaMensajes.visualizarColumna(xsListaOpciones::tipoColumna::Texto,"text",1);
  
  // Conecta la Señal del Opcion
  Entero columnaTexto = 1;
  oListaMensajes.conectarSenal(XS_EVENTO_CAMBIADO,XS_FUNCION_RETORNO (fnOpcionSeleccionada),&columnaTexto);
  
  // Agregamos la Lista al Contenedor
  oVentana.agregarAlContenedor(oListaMensajes.obtenerManejador());

  // Creamos una Entrada
  entDato.crear("Capture dato Insertar-Modificar");

  // Agregamos la Entrada al Contenedor
  oVentana.agregarAlContenedor(entDato.obtenerManejador());

  // Creamos un botón de Insertar
  xsBoton btnInsertar("Insertar",FALSO);

  // Capturamos la señal del Botón de Insertar
  btnInsertar.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnInsertar),oListaMensajes.obtenerManejador());

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnInsertar.obtenerManejador());

  // Creamos un botón de Modificar
  xsBoton btnModificar("Modificar",FALSO);

  // Capturamos la señal del Botón de Modificar
  btnModificar.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnModificarSeleccionado),oListaMensajes.obtenerManejador());

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnModificar.obtenerManejador());

  // Creamos un botón de Eliminar
  xsBoton btnEliminarSeleccionado("Eliminar Seleccionado",FALSO);

  // Capturamos la señal del Botón de Eliminar
  btnEliminarSeleccionado.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnEliminarSeleccionado),oListaMensajes.obtenerManejador());

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnEliminarSeleccionado.obtenerManejador());

  // Creamos un botón de Eliminar
  xsBoton btnEliminarPrimero("Eliminar Primero",FALSO);

  // Capturamos la señal del Botón de Eliminar
  btnEliminarPrimero.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnEliminarPrimero),oListaMensajes.obtenerManejador());

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnEliminarPrimero.obtenerManejador());

  // Creamos un botón de Seleccionar
  xsBoton btnSeleccionar("Seleccionar el Primero",FALSO);

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnSeleccionar.obtenerManejador());

  // Capturamos la señal del Botón de Seleccionar
  btnSeleccionar.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnSeleccionarPrimero),oListaMensajes.obtenerManejador());

  // Creamos un botón de DesSeleccionar
  xsBoton btnDesSeleccionar("DesSeleccionar",FALSO);

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnDesSeleccionar.obtenerManejador());

  // Capturamos la señal del Botón de DesSeleccionar
  btnDesSeleccionar.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnDesSeleccionar),oListaMensajes.obtenerManejador());

  // Creamos un botón de Eliminar Todos
  xsBoton btnEliminarTodos("Eliminar Todos",FALSO);

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnEliminarTodos.obtenerManejador());

  // Capturamos la señal del Botón de Eliminar Todos
  btnEliminarTodos.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnEliminarTodos),oListaMensajes.obtenerManejador());

  // Creamos un botón de Desplegar Todos
  xsBoton btnDesplegarTodos("Desplegar Todos",FALSO);

  // Agregamos el botón al contenedor
  oVentana.agregarAlContenedor(btnDesplegarTodos.obtenerManejador());

  // Capturamos la señal del Botón de Desplegar Todos
  btnDesplegarTodos.conectarSenal(XS_EVENTO_CLICKED,XS_FUNCION_RETORNO (fnDesplegarTodos),oListaMensajes.obtenerManejador());

  // Imprime el numero de elementos
  xsImprimir("Elementos en la Lista");
  xsImprimir(oListaMensajes.longitud());
  
  // Muestra todos los objetos
  oVentana.mostrarTodo();

  // Ciclo
  xsAppCiclo;

  // Finaliza retornando 0
  retorna 0;

}


// Detiene el Ciclo Principal iniciado por gtk_main cuando la ventana es destruida
Estatica Vacio fnSalida(xsObjetoGUI* ventana, xsApuntador datos)
{
  // Llama a la función de la Librería que sale del Ciclo Main  
  xsAppSalida;
}

// Función para controlar el Cierre de una Ventana
Estatica Entero fnCierre(xsObjetoGUI* ventana, xsEvento *evento)
{
  retorna Falso; // Para que se cierre, lo contrario para que no se cierre
}

// Función para crear el Arbol para el Modelo del Combo
Estatica xsModeloArbol* fnCrearModeloMensajes (Vacio)
{
  // referencias a los iconos
  Constante Caracter *nombreIconos[] = 
  {
    // Nombres de los Iconos
    "dialog-warning",
    "process-stop",
    "document-new",
    "edit-clear",
    NULO,
    "document-open"
  };
  
  // Referencias a los Mensajes
  Constante Caracter *mensajes[] = 
  {
    N_("Advertencia"),
    N_("Detener"),
    N_("Nuevo"),
    N_("Limpiar"),
    NULO,
    N_("Abrir")
  };

  // Variables
  xsArbolIterador iterador;
  xsListaDatos*   lista;
  Entero          indice;

  // Crea la Lista de Datos
  lista = xsObjeto_Lista_crear (2, XS_TIPO_CADENA, XS_TIPO_CADENA);

  ciclo (indice = 0; indice < G_N_ELEMENTS (nombreIconos); indice++)
  {
      // Verifica que no sea nulo
      si (nombreIconos[indice])
      {
          // Agrega un Iterador a la Lista
          xsObjeto_Lista_agregar (lista, &iterador);
          xsObjeto_Lista_colocar (lista, &iterador,
                                  COLUMNA_ICONO, nombreIconos[indice],
                                  COLUMNA_TEXTO, _(mensajes[indice]),
                                  -1);
      }
      deOtroModo
      {
          xsObjeto_Lista_agregar (lista, &iterador);
          xsObjeto_Lista_colocar (lista, &iterador,
                                  COLUMNA_ICONO, NULO,
                                  COLUMNA_TEXTO, XS_OPCION_SEPARADOR,
                                  -1);
        }
    }

  // Retorna la Lista como un Modelo de Arbol
  retorna XS_ARBOL_MODELO (lista);
}

// Función para controlar opción Seleccionada
Vacio fnOpcionSeleccionada(xsObjetoGUI* objeto, Entero* columna)
{

  // Crea un objeto opcionTexto
  xsListaOpciones lista;
  lista.crear();

  // Le asigna el manejador
  lista.asignarManejador(objeto);

  // Coloca el Texto en la Entrada
  entDato.colocarTexto(lista.obtenerSeleccionado(*columna));

  // Imprime el indice
  xsImprimir("Indice del Seleccionado");
  xsImprimir(lista.obtenerSeleccionado());
}


// Función para Insertar
Vacio fnInsertar(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));
   
   // Define un vector de datos para agrega un Renglon
   vector<xsListaOpciones::renglonListaOpciones> arrRenglon;

   // Defino un dato para establecer el renglon
   xsListaOpciones::renglonListaOpciones renglon;

   // Establezco lo que tendrá el renglón
   renglon.tipo = xsListaOpciones::tipoColumna::Texto;
   renglon.posicion = 0;
   renglon.texto="contact-new";  // Para el Icono de la Librería
   
   // Agrega el dato al arreglo
   arrRenglon.push_back(renglon);

   // Establezco lo que tendrá el renglon
   renglon.tipo = xsListaOpciones::tipoColumna::Texto;
   renglon.posicion = 1;
   renglon.texto =entDato.obtenerTexto();
   
   // Agrega el dato al arreglo
   arrRenglon.push_back(renglon);

   // Verifica que haya capturado algo
   si (entDato.obtenerLongitudTexto()>0)
   {
      // Inserta
      lstTemporal.insertar(arrRenglon);

      // Lo activa
      lstTemporal.seleccionar(0);
   }
   deOtroModo
      xsVentana::mensajeInformacion("xsEasyCpp - Demo ListaOpciones","Capture dato para insertar");
}

// Función para modificar el Seleccionado
Vacio fnModificarSeleccionado(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Verifica que haya capturado algo
   si (entDato.obtenerLongitudTexto()>0)
      // Modifica el Seleccionado
      lstTemporal.modificarSeleccionado(1,entDato.obtenerTexto());
   deOtroModo
      xsVentana::mensajeInformacion("xsEasyCpp - Demo ListaOpciones","Capture dato para modificar");
}

// Función para eliminar el Seleccionado
Vacio fnEliminarSeleccionado(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Modifica el Seleccionado
   lstTemporal.eliminarSeleccionado();

   // Imprime
   xsImprimir("Longitud despues de Borrar:");
   xsImprimir(lstTemporal.longitud());
}

// Función para eliminar el Primero
Vacio fnEliminarPrimero(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Modifica el Seleccionado
   lstTemporal.eliminar(0);

   // Imprime
   xsImprimir("Longitud despues de Borrar el Primero:");
   xsImprimir(lstTemporal.longitud());
}


// Función para Seleccionar el Primero
Vacio fnSeleccionarPrimero(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Selecciona el Primero
   lstTemporal.seleccionar(0);
}

// Función para DesSeleccionar
Vacio fnDesSeleccionar(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // DesSelecciona el Primero
   lstTemporal.seleccionar(-1);

   xsImprimir("Longitud despues de DesSeleccionar Todos:");
   xsImprimir(lstTemporal.longitud());

}

// Función para eliminar Todos
Vacio fnEliminarTodos(xsObjetoGUI* boton, xsApuntador lista)
{
   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Modifica el Seleccionado
   lstTemporal.limpiar();

   // Imprime
   xsImprimir("Longitud despues de Borrar Todos:");
   xsImprimir(lstTemporal.longitud());
}

// Función para Desplegar Todos
Vacio fnDesplegarTodos(xsObjetoGUI* boton, xsApuntador lista)
{
   // Para obtener el texto
   Caracter* texto;

   // Lista Temporal
   xsListaOpciones lstTemporal;

   // Asignamos los manejadores
   lstTemporal.asignarManejador(XS_OBJETOGUI(lista));

   // Variable para la ruta (indice)
	xsCadena ruta;

	// Variable para el Indice
	Entero indice;

	// Variable para el Modelo
	xsModeloArbol*  modelo;

    // Variable para el Iterador
	xsArbolIterador iterador;

	// Obtiene el Modelo
   modelo = xsObjeto_Opcion_obtener_modelo(XS_OPCION(lstTemporal.obtenerManejador()));

   // Elementos en la lista
   Entero elementos=lstTemporal.longitud();

   // Ciclo
   xsImprimir("Imprimiendo los elementos de la Lista ...");

	// Ciclo para verificar cada dato
	for (indice=0;indice<elementos;indice++)
	{
		// Obtiene la ruta por el indice
		ruta = to_string(indice);	
		
		// Verifica que obtuvo algo
		si (xsObjeto_Arbol_obtener_iterador_cadena (modelo, &iterador,ruta.c_str()))
		{
         xsObjeto_Arbol_obtener_modelo(modelo, &iterador, 1, &texto,  -1);
         xsVentana::mensajeInformacion("xsEasyCpp Demo ListaOpciones",texto);
		}
	}	

}
